﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Rubenhak.Utils;

namespace TestApplication
{
    class Program
    {
        static void Main(string[] args)
        {
            Person obj = new Person() { Name = "John" };

            Console.WriteLine(string.Format("(obj is IPerson) == {0}", obj is IPerson));

            IPerson iperson = ObjectCaster<IPerson>.As(obj);
            iperson.Initialized += ((sender, e) => Console.WriteLine("Initialized Called, sender: " + sender.ToString()));

            Console.WriteLine("Person> " + obj.Name);
            Console.WriteLine("IPerson> " + iperson.Name);

            iperson.Name = "Steve";

            Console.WriteLine("Person> " + obj.Name);
            Console.WriteLine("IPerson> " + iperson.Name);

            iperson.Initialize();

            Console.WriteLine("Person> " + obj.Name);
            Console.WriteLine("IPerson> " + iperson.Name);

            Console.ReadLine();
        }
    }



}
